## ignition-utils 1.2.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-utils1 VERSION 1.2.0)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake2 2.0.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
set(c++standard 17)
ign_configure_project(VERSION_SUFFIX)

#============================================================================
# Set project-specific options
#============================================================================

option(
  IGN_UTILS_VENDOR_CLI11
  "If true, use the vendored version of CLI11, otherwise use an external one"
  true)

#============================================================================
# Search for project-specific dependencies
#============================================================================

if(NOT IGN_UTILS_VENDOR_CLI11)
  # PKGCONFIG_IGNORE can be removed once pkg-config support in CLI11 (see
  # https://github.com/CLIUtils/CLI11/pull/523) is released
  ign_find_package(CLI11 REQUIRED_BY cli PKGCONFIG_IGNORE)
endif()

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS
  COMPONENTS cli)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Configure documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md")

=== src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)

ign_create_core_library(SOURCES ${sources} CXX_STANDARD ${c++standard})
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

=== test/CMakeLists.txt ===
include_directories (
  ${PROJECT_SOURCE_DIR}/test/gtest/include
  ${PROJECT_SOURCE_DIR}/test/gtest
  ${PROJECT_SOURCE_DIR}/test
  ${CMAKE_BINARY_DIR}/include
)

configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)

# Build gtest
add_library(gtest STATIC gtest/src/gtest-all.cc)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)
set_property(TARGET gtest_main PROPERTY CXX_STANDARD ${c++standard})
set_property(TARGET gtest PROPERTY CXX_STANDARD ${c++standard})
set(GTEST_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest.a")
set(GTEST_MAIN_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest_main.a")

execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
include_directories(${GTEST_INCLUDE_DIRS})

#============================================================================
# Do a fake install of ign-utils in order to test the examples.
#============================================================================
set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")

file(MAKE_DIRECTORY ${FAKE_INSTALL_PREFIX})

include(ExternalProject)
ExternalProject_Add(
  FAKE_INSTALL

  SOURCE_DIR "${CMAKE_SOURCE_DIR}"
  EXCLUDE_FROM_ALL 1
  LOG_CONFIGURE 1
  LOG_BUILD 1
  LOG_INSTALL 1
  CMAKE_ARGS
    "-DBUILD_TESTING=OFF"
    "-DCMAKE_INSTALL_PREFIX=${FAKE_INSTALL_PREFIX}"
)

add_subdirectory(integration)
add_subdirectory(performance)
add_subdirectory(regression)

=== cli/include/CMakeLists.txt ===
# As the include headers in the source tree are not in the usual location
# to support the vendored and not vendored case, we need to manually call
# add_subdirectory of the correct directory, and
# target_include_directories(@tgt@ INTERFACE "$<BUILD_INTERFACE:@incl_dirs>")
# that for the usual include directories are handled by ign_add_component
if(IGN_UTILS_VENDOR_CLI11)
  add_subdirectory(vendored-cli/ignition/utils)
  target_include_directories(${ign_utils_cli_target_name} 
    INTERFACE
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/cli/include/vendored-cli>")
else()
  add_subdirectory(external-cli/ignition/utils)
  target_include_directories(${ign_utils_cli_target_name} 
    INTERFACE 
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/cli/include/external-cli>")
endif()

=== cli/src/CMakeLists.txt ===
ign_add_component(
  cli 
  INTERFACE 
  INDEPENDENT_FROM_PROJECT_LIB
  GET_TARGET_NAME ign_utils_cli_target_name)

# Make sure that the name is visible also in cli/include/CMakeLists.txt
set(ign_utils_cli_target_name ${ign_utils_cli_target_name} PARENT_SCOPE)
if(NOT IGN_UTILS_VENDOR_CLI11)
  target_link_libraries(${ign_utils_cli_target_name} INTERFACE CLI11::CLI11)
endif()

=== examples/using_cli/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(ignition-utils-cli-demo)

# Find the Ignition Libraries used directly by the example
find_package(ignition-utils1 REQUIRED COMPONENTS cli)
set(IGN_UTILS_VER ${ignition-utils1_VERSION_MAJOR})

add_executable(${PROJECT_NAME} main.cc)
target_link_libraries(
  ${PROJECT_NAME}
  ignition-utils${IGN_UTILS_VER}::cli
)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

ign_get_sources(tests)

# Test symbols having the right name on linux only
if (UNIX AND NOT APPLE)
  configure_file(all_symbols_have_version.bash.in ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash @ONLY)
  add_test(NAME INTEGRATION_versioned_symbols
    COMMAND bash ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash $<TARGET_FILE:${PROJECT_LIBRARY_TARGET_NAME}>)
endif()

ign_build_tests(TYPE INTEGRATION SOURCES ${tests})

add_subdirectory(implptr)

=== test/integration/implptr/CMakeLists.txt ===
add_library(implptr_test_classes SHARED implptr_test_classes.cc)

target_link_libraries(implptr_test_classes
  ${PROJECT_LIBRARY_TARGET_NAME}
)

# Piggyback on the auto-generated dll exports for Windows
target_compile_definitions(
  implptr_test_classes
  PRIVATE
  -Dignition_utils${PROJECT_VERSION_MAJOR}_EXPORTS
)

ign_build_tests(TYPE INTEGRATION SOURCES ImplPtr_TEST.cc)

target_link_libraries(INTEGRATION_ImplPtr_TEST
  implptr_test_classes
)

=== cli/include/external-cli/ignition/utils/CMakeLists.txt ===
ign_install_all_headers(COMPONENT cli)

=== debian/changelog ===
ignition-utils (1.2.0+ds-1) unstable; urgency=medium

  * New upstream version 1.2.0+ds

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 04 Feb 2022 11:39:02 +0000

ignition-utils (1.1.0+ds-4) unstable; urgency=medium

  * Move package under debian-science group
  * Add Breaks+Replaces for -utils-cli-dev (Closes: #1001378)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 09 Dec 2021 12:09:40 +0000

ignition-utils (1.1.0+ds-3) unstable; urgency=medium

  * Setup test when using cmake with components
  * Use License for Apatche-2 in its own section
  * Remove -cli-dev package
  * Remove -cli pkgconfig file
  * Need custom cmake files to avoid problems with the fake library removed
  * Added copyright for debian/*

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 07 Dec 2021 22:42:44 +0000

ignition-utils (1.1.0+ds-2) unstable; urgency=medium

  * Add autopkgtest running cmake and pkgconfig
  * Support for cli: build-d on libcli11-dev
  * Need to change CMake/pkg-config helpers according to the removal
    of the library

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 03 Nov 2021 14:11:26 +0000

ignition-utils (1.1.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #990040)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 07 Sep 2021 18:39:27 +0000

=== debian/control ===
Source: ignition-utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               doxygen,
               libcli11-dev,
               libgtest-dev,
               libignition-cmake-dev
Standards-Version: 4.6.0
XS-Ruby-Versions: all
Vcs-Browser: https://salsa.debian.org/science-team/ignition-utils
Vcs-Git: https://salsa.debian.org/science-team/ignition-utils.git
Rules-Requires-Root: no
Homepage: http://ignitionrobotics.org/libs/utils

Package: libignition-utils-dev
Architecture: any
Section: libdevel
Depends: libcli11-dev,
         libignition-cmake-dev,
         ${misc:Depends}
Multi-Arch: same
Breaks: libignition-utils-cli-dev (<< 1.1.0+ds-3)
Replaces: libignition-utils-cli-dev (<< 1.1.0+ds-3)
Description: Ignition Utils Library - Development files
 Provides general purpose classes and functions designed for robotic
 applications.
 .
 Ignition Utils provides a wide range of functionality, including:
   - A helper class to implement the PIMPL pattern
   - A command line parsing utility
   - Macros to suppress warnings
 The package also includes CLI -dev support

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- \
           -DIGN_UTILS_VENDOR_CLI11=OFF

execute_after_dh_auto_install:
	# 1. Upstream is using a fake/empty library to make ign-cmake
	# to generate cmake/pkgconfig and visibility files.
	# Do not need to install it. Also need to remove the cmake/pkgconfig
	# file hosting the library path
	rm debian/libignition-utils-dev/usr/lib/*/libignition-utils*.so*
	rm debian/libignition-utils-dev/usr/lib/*/cmake/ignition-utils*/ignition-utils*-targets-none.cmake
	sed -i -e "s/\(Libs:.*\)-lignition-utils[0-99]\(.*\)/\1\2/g" debian/libignition-utils-dev/usr/lib/*/pkgconfig/ignition-utils*.pc
	rm debian/libignition-utils-dev/usr/lib/*/pkgconfig/ignition-utils*-cli.pc
	# 2. Remove build paths from tag file for reproducible builds
	sed -i -e 's:$(CURDIR)/::g' debian/libignition-utils-dev/usr/share/ignition/ignition-utils*/ignition-utils*.tag.xml

%:
	dh $@

=== debian/tests/control ===
Tests: test test-cli
Depends: @, build-essential, cmake, pkg-config

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
    dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,repacksuffix=+ds \
    https://github.com/ignitionrobotics/ign-utils/tags \
		(?:.*?/)@PACKAGE@.*_(\d[\d.]*)\.tar\.gz

## ignition-utils 1.5.1%2Bds

=== debian/changelog ===
ignition-utils (1.5.1+ds-1.1~revyos1) bullseye; urgency=medium

  * Release for RevyOS riscv64

 -- CHEN Xuan <chenxuan@iscas.ac.cn>  Wed, 22 May 2024 13:16:03 +0800

ignition-utils (1.5.1+ds-1) unstable; urgency=medium

  [ Jose Luis Rivero ]
  * Nede to update cmake helpers

  [ Debian Janitor ]
  * Fix day-of-week for changelog entry 1.1.0+ds-2.
  * Update standards version to 4.6.2, no changes needed.

  [ Jose Luis Rivero ]
  * New upstream version 1.5.1+ds
  * Rediff patches

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 10 Aug 2023 11:12:18 +0200

## ignition-utils 1.5.1+ds

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libcli11-dev,
                libgtest-dev,
                libignition-cmake-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 XS-Ruby-Versions: all
 Vcs-Browser: https://salsa.debian.org/science-team/ignition-utils
 Vcs-Git: https://salsa.debian.org/science-team/ignition-utils.git
